<?php
namespace Teknisa\CTB\Controllers;

use Teknisa\CTB\Services\Ger08000ContadorService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;

class Ger08000ContadorController extends \Teknisa\CTB\Controllers\TeknisaCrud {

    protected $dataSourceName = "contador_endereco";
    protected $parameterBagColumns = array();

    public function __construct($crudService, ParameterBag $parameterBag, Ger08000ContadorService $serviceContador) {
        $this->serviceContador = $serviceContador;
        parent::__construct($crudService, $parameterBag);
    }

    public function verificaCdContador(DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            // Valida se já existe um lote com o mesmo código informado na tela.
            $this->serviceContador->verificaCdContador($row);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function contador_com_endereco(DTO\Request\Filter $request, DTO\Response $response){
        try{
            $this->dataSourceName = "contador_endereco";
            $this->parameterBagColumns = array("NRORG");
            parent::find($request, $response);
        }catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}
